#version 330 core

layout (location = 0) in vec4 vertex; // <vec2 pos, vec2 tex>
layout (location = 1) in vec4 colorin; 
layout (location = 2) in float finalopaque; 
layout (location = 3) in vec3 selectcolor;
layout (location = 4) in vec2 offset;

out vec4 ourcolor;
out vec2 texcoord;
out float finalopaquevalue;

uniform vec2 move = {0.0,0.0};
uniform float zoom = 1.0;

uniform int selectcheck = 0;
uniform int singleormultiple = 0;  //0 for multiple, 1 for single
uniform int vertexinstancecheck = 0; //{onlyvertex = 0, onlyinstance, vertexandinstance, vertexorinstance}
uniform int stainvertexinstancecheck = 0; //{onlyvertex = 0, onlyinstance, vertexandinstance, vertexorinstance}

uniform int staincheck = 1;
uniform vec4 staincolor = {1.0,0.0,0.0,1.0};
uniform float stainmix = 1.0;

uniform int instanceid = 17;
uniform int vertexid = 1;
uniform int instancerange = 2;
uniform int vertexrange = 1;

uniform int staininstanceid = 17;
uniform int stainvertexid = 1;
uniform int staininstancerange = 2;
uniform int stainvertexrange = 1;


void skip(){
     gl_Position = vec4(-2.0,0.0,0.0,1.0);
}


void staininrange(){
	         ourcolor = mix(colorin , staincolor, stainmix);
		     finalopaquevalue = mix(finalopaque, staincolor.a, stainmix); 
}

void stainnotinrange(){
		     ourcolor = colorin;
	         finalopaquevalue = finalopaque;
}


void inrange(){
         gl_Position = vec4((vertex.xy + offset + move*zoom), 0.0, zoom);
	     texcoord = vertex.zw;
         if(staincheck == 1) {


			 if(stainvertexinstancecheck == 0){ //{onlyvertex, onlyinstance, vertexandinstance, vertexorinstance}
                  if(gl_VertexID >= stainvertexid && gl_VertexID < stainvertexid+stainvertexrange) 
                        staininrange();
				  else   
	                    stainnotinrange();
             }else if(stainvertexinstancecheck == 1){ //{onlyvertex, onlyinstance, vertexandinstance, vertexorinstance}
                  if(gl_InstanceID >= staininstanceid && gl_InstanceID < staininstanceid+staininstancerange)
                        staininrange();
				  else   
	                    stainnotinrange();
             }else if(stainvertexinstancecheck == 2){ //{onlyvertex, onlyinstance, vertexandinstance, vertexorinstance}
                  if((gl_VertexID >= stainvertexid && gl_VertexID < stainvertexid+stainvertexrange) && (gl_InstanceID >= staininstanceid && gl_InstanceID < staininstanceid+staininstancerange))
                        staininrange();
				  else   
	                    stainnotinrange();
             }else if(stainvertexinstancecheck == 3){ //{onlyvertex, onlyinstance, vertexandinstance, vertexorinstance}
                  if((gl_VertexID >= stainvertexid && gl_VertexID < stainvertexid+stainvertexrange) || (gl_InstanceID >= staininstanceid && gl_InstanceID < staininstanceid+staininstancerange))
                        staininrange();
		          else   
	                    stainnotinrange();
		     }


         }else{  //'staincheck == 1' else
		     ourcolor = colorin;
	         finalopaquevalue = finalopaque;
		 }
}



void selectinrange(){
	float r,g,b;
	r = selectcolor.r * 255;
	g = selectcolor.g * 255;
	g += gl_InstanceID;
	if(g>255){
	    r++;
	    g -= 256;
	}
    r/=255.0;
	g/=255.0;	
	gl_Position = vec4((vertex.xy + offset + move*zoom), 0.0, zoom);
	ourcolor = vec4(r,g,selectcolor.b,1.0);
}


void main()
{
//gl_Position = vec4((vertex.xy + offset + move*zoom), 0.0, zoom);

if(selectcheck > 0){


if(singleormultiple == 0)
	     selectinrange();
else if(vertexinstancecheck == 0){ //{onlyvertex, onlyinstance, vertexandinstance, vertexorinstance}
    if(gl_VertexID >= vertexid && gl_VertexID < vertexid+vertexrange) 
         selectinrange();
    else
         skip();     
}else if(vertexinstancecheck == 1){ //{onlyvertex, onlyinstance, vertexandinstance, vertexorinstance}
   if(gl_InstanceID >= instanceid && gl_InstanceID < instanceid+instancerange)
         selectinrange();
    else
         skip();  
}else if(vertexinstancecheck == 2){ //{onlyvertex, onlyinstance, vertexandinstance, vertexorinstance}
   if((gl_VertexID >= vertexid && gl_VertexID < vertexid+vertexrange) && (gl_InstanceID >= instanceid && gl_InstanceID < instanceid+instancerange))
         selectinrange();
    else
         skip();  
}else if(vertexinstancecheck == 3){ //{onlyvertex, onlyinstance, vertexandinstance, vertexorinstance}
   if((gl_VertexID >= vertexid && gl_VertexID < vertexid+vertexrange) || (gl_InstanceID >= instanceid && gl_InstanceID < instanceid+instancerange))
         selectinrange();
    else
         skip();  
}


}else{ //selectcheck else


if(singleormultiple == 0)
	     inrange();
else if(vertexinstancecheck == 0){ //{onlyvertex, onlyinstance, vertexandinstance, vertexorinstance}

    if(gl_VertexID >= vertexid && gl_VertexID < vertexid+vertexrange) 
         inrange();
   else
       skip();     

}else
if(vertexinstancecheck == 1){ //{onlyvertex, onlyinstance, vertexandinstance, vertexorinstance}

   if(gl_InstanceID >= instanceid && gl_InstanceID < instanceid+instancerange)
         inrange();
   else
       skip();     

}else
if(vertexinstancecheck == 2){ //{onlyvertex, onlyinstance, vertexandinstance, vertexorinstance}

   if((gl_VertexID >= vertexid && gl_VertexID < vertexid+vertexrange) && (gl_InstanceID >= instanceid && gl_InstanceID < instanceid+instancerange))
         inrange();
   else
       skip();     

}else
if(vertexinstancecheck == 3){ //{onlyvertex, onlyinstance, vertexandinstance, vertexorinstance}

   if((gl_VertexID >= vertexid && gl_VertexID < vertexid+vertexrange) || (gl_InstanceID >= instanceid && gl_InstanceID < instanceid+instancerange))
         inrange();
   else
       skip();     

}



}//selectcheck else end



}//main end
